from zope.publisher.interfaces import browser
from zope.app.pagetemplate import ViewPageTemplateFile
from zope.formlib import namedtemplate

from timeclock.interfaces import ITimeClockApplication
from zope.app import zapi

class ITimeClockLayer(browser.ILayer, browser.IBrowserRequest):
    """TimeClock layer."""

class ITimeClockSkin(ITimeClockLayer, browser.IDefaultBrowserLayer):
    """The TimeClock skin"""

defaultNamedTemplate = namedtemplate.NamedTemplateImplementation(ViewPageTemplateFile('defaultforms.pt'))
defaultNamedTemplate.__name__ = "default"

class NavigationView(object):

    def links(self):
        app = ITimeClockApplication(self.context)
        links = []
        links.append({'title':'Users','url':zapi.absoluteURL(app['users'], self.request)})
        links.append({'title':'Work Logs','url':zapi.absoluteURL(app['workLogs'], self.request)})
        return links
