from zope.app import zapi
from zope.app.form.interfaces import IInputWidget
from zope.app.form.browser.widget import SimpleInputWidget, renderElement
from zope.app.pagetemplate.viewpagetemplatefile import ViewPageTemplateFile
import datetime
date = datetime.datetime.today()

from timeclock.app import getTimeClockApplication

class PersonWidget(SimpleInputWidget):
    """Widget for Person objects."""

    tag="select"

    def _getOptions(self):
        options = ''
        for person in getTimeClockApplication()['users'].values():
            options += renderElement('option',
                                     value=person.login,
                                     contents=person.title
                                     )
        return options

    def _toFieldValue(self, input):
        return getTimeClockApplication()['users'][input]

    def __call__(self):
        return renderElement(self.tag,
                             name=self.name,
                             contents=self._getOptions()
                            )
